program primzahlfinder;

{ Didaktisch: Unterschied Funktion - Prozedur
              Effizienzberlegungen (Komplexitt)
              }

uses crt;
var max: longint;
    zahl: longint;
    feld: array[1..64000] of boolean;

function primzahl(n: longint): boolean;
var teiler: longint;
begin
  primzahl := true;
  teiler := 2;
  while teiler <= sqrt(n) do
    if zahl mod teiler = 0 then begin
      primzahl := false;
      teiler := n
    end
    else
      inc(teiler);
end;

procedure eratosthenes;
var n,i: longint;
begin
  for n := 1 to max do
    feld[n] := true;
  n := 2;
  while n <= sqrt(max) do begin
    if feld[n] = true then begin
      i := n*2;
      while i <= max do begin
        feld[i] := false;
        inc(i,n);
      end;
    end;
    inc(n);
  end;
end;


begin
  clrscr;
  writeln('Primzahlfinder');
  writeln('Bis zu welcher Zahl (max. 64000)? ');
  readln(max);
  write('Eratosthenes - Start? ');
  readln;
  eratosthenes;
  writeln('...fertig! Ausgabe? ');
  readln;
  for zahl := 1 to max do
    if feld[zahl] = true then write(zahl, ' ');
  writeln;
  write('Primzahlfunktion - Start? ');
  readln;
  for zahl := 1 to max do
    if primzahl(zahl) then write(zahl, ' ');
  readln;
end.